<template>
  <t-modal
    v-model="vModel"
    id="_delete-circuit-modal"
    :clickToClose="false"
    @before-open="onBeforeOpen"
    @closed="onClosed"
  >

    <!-- Circuit icon -->
    <CircuitIcon
      width="120"
      :fill="GLOBALS.__THEME_DARK_3_COLOR__"
      class="mx-auto"
    />

    <!-- Title -->
    <p class="text-center text-xl mb-4">{{ $t('circuit.deleteCircuit') | capitalize }}</p>

    <!-- Text content -->
    <p class="text-center">{{ $t('modals.deleteCircuitModal.text1') }}</p>

    <!-- Footer -->
    <template v-slot:footer>
      <div class="flex justify-center">
        <Button
          variant="primary"
          @click.native="handleOk"
          class="mx-2"
        >
          {{ $t('global.confirm') | capitalize }}
        </Button>
        <Button
          variant="error"
          @click.native="vModel = false"
          class="mx-2"
        >
          {{ $t('global.cancel') | capitalize }}
        </Button>
      </div>
    </template>

  </t-modal>

</template>

<script>
import { mapState, mapActions } from 'vuex'
// BaseModal component
import BaseModal from './BaseModal'
/**
 * DeleteCircuitModal component
 */
export default {
  name: 'DeleteCircuitModal',
  extends: BaseModal,
  computed: {
    // Map state from 'Circuits' module
    ...mapState('Circuits', [
      'circuits',
      'circuitToDelete'
    ])
  },
  methods: {
    // Map actions from 'Circuits' module
    ...mapActions('Circuits', [
      'loadCircuits',
      'getCircuitStatus',
      'deleteCircuit'
    ]),
    /**
     * Called before popup open
     * @return {void}
     */
    onBeforeOpen () {
      // ...
    },
    /**
     * Called when click on confirm button
     * @return {void}
     */
    handleOk () {
      this.confirmDelete()
      this.vModel = false
    },
    /**
     * Called when click on confirm button
     * @return {void}
     */
    async confirmDelete () {
      // Wait for delete circuit function
      const deleteCircuitResponse = await this.deleteCircuit(this.circuitToDelete)
      // If passed
      if (!(deleteCircuitResponse instanceof Error)) {
        // Reload circuits
        await this.loadCircuits()
        // Loop on circuits
        for (const circuit of this.circuits) {
          // Get & set circuit status
          this.getCircuitStatus(circuit.id)
        }
      }
    },
    /**
     * Called when popup close
     * @return {void}
     */
    onClosed () {
      // Force reset on closed
      this.$store.commit('Circuits/SET_CIRCUIT_TO_DELETE', null)
    }
  }
}
</script>

<style lang="scss">
#_delete-circuit-modal {
  //
}
</style>
